Page MenuHomePhabricator

Open here to edit: As a user of the Wikipedia iOS app, I would like to be able to quickly edit a specific string in an article
Closed, ResolvedPublic

Description

Why are we doing this?

Based on the work that Jess Klein on the Contributions team has done around focus we would like to have a way for users to quickly take editing actions from the article view without having to re-find what they would like to edit once they have entered the editing view. This work will also most likely build off of Android's highlight to edit feature.

User story

As a user of the Wikipedia iOS app, I would like to be able to quickly edit a specific string in an article

Mocks

Highlighting text in the article viewAfter selecting 'edit' from the highlight menu
Zeplin: https://zpl.io/VOmJL5LZeplin: https://zpl.io/2ZkpwK4
Highlighting a non-editable stringAlert
Zeplin: https://zpl.io/VOP5xzrZeplin: https://zpl.io/br8Qvze

Design details

  • Tapping (eg. placing focus) into the highlighted area while in the editing view will dismiss the highlight

Event Timeline

cmadeo created this task.Feb 6 2019, 6:53 PM
cmadeo updated the task description. (Show Details)Feb 8 2019, 9:37 PM

This is ready for Needs Acceptance Criteria whenever there is an appropriate board 😺

Note to self: Make the highlight different from the Selection color

JMinor triaged this task as Medium priority.Feb 20 2019, 11:17 PM
JMinor moved this task from Backlog to Prioritized on the Wikipedia-iOS-App-Backlog (Design) board.
Mhurd claimed this task.Feb 27 2019, 8:26 PM

Some notes...

With help from Android folks, I learned...

  • relevant Android approach & code
  • it would be nice for this to be smart enough to show the title description editor if the wikidata description is highlighted and the user taps Edit (Android handles this)

It also seems there are conditions under which it may not make sense to show the "Edit" button on selection, for example...


...perhaps we only show it if the selection is text only?

cmadeo updated the task description. (Show Details)Feb 28 2019, 7:45 PM

@Mhurd good point. Is there anyway to only exclude info boxes?

Mhurd added a comment.Feb 28 2019, 7:48 PM

@cmadeo there's a similar issue anytime selection encompasses more than text - especially if one end of the selection range is in the middle something... may be easier to play with edge cases once the basic functionality is wired up :)

@Mhurd oof right, good point!

Mhurd added a comment.Mar 7 2019, 11:59 PM

@cmadeo PR is up with animation and some edge-case screenshots :)

cmadeo updated the task description. (Show Details)Mar 8 2019, 8:11 PM

Updated task description to reflect the conversation that @Mhurd and I had today. We will persist the highlight UNLESS the user taps into the highlighted area.

cmadeo updated the task description. (Show Details)Mar 8 2019, 9:14 PM

@Mhurd this is working really well so far! YAY! But on the current beta build I'm not seeing any instances where the non-editable alert is showing (eg. over templates, across sections, very long strings or the title). If I forgot something that we made a different decision on would you mind reminding me what we had decided instead? I do think that at the very least on Titles and across sections it'd be helpful to show the alert instead of bringing them to the editor OR we could bring them to the editor but also show an alert of some kind explaining why the behavior is different than expected.

Mhurd added a comment.Mar 20 2019, 6:04 PM

@cmadeo

Haha oh that's cause I didn't see you'd added the alert mock ;)

I'll add it! :)

cmadeo added a subscriber: Mhurd.Mar 20 2019, 6:09 PM

Woot! Thanks @Monte Hurd <mhurd@wikimedia.org> :)

Mhurd added a comment.Mar 23 2019, 6:39 AM

@cmadeo The PR above adds the alert :)

Oh it also hides the "Edit" item if the user doesn't have permission to edit - protected pages etc.

Just cut build so as soon as that gets released should be testable.

Awesome, @Mhurd! Just played around with it on the new build

cmadeo added a project: Product-QA.

@Mhurd working and looking good to me! Thank you!

ABorbaWMF added a subscriber: ABorbaWMF.

Works well for me on 6.2.1 (1594) and the previous build.

JMinor closed this task as Resolved.Apr 9 2019, 5:23 PM